hdu 1159 Common Subsequence(最长公共子序列 DP) Common Subsequence

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1159

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 25416    Accepted Submission(s): 11276


Problem Description
A subsequence of a given sequence is the given sequence with some elements (possible none) left out. Given a sequence X = <x1, x2, ..., xm> another sequence Z = <z1, z2, ..., zk> is a subsequence of X if there exists a strictly increasing sequence <i1, i2, ..., ik> of indices of X such that for all j = 1,2,...,k, xij = zj. For example, Z = <a, b, f, c> is a subsequence of X = <a, b, c, f, b, c> with index sequence <1, 2, 4, 6>. Given two sequences X and Y the problem is to find the length of the maximum-length common subsequence of X and Y.
The program input is from a text file. Each data set in the file contains two strings representing the given sequences. The sequences are separated by any number of white spaces. The input data are correct. For each set of data the program prints on the standard output the length of the maximum-length common subsequence from the beginning of a separate line.
 
Sample Input
abcfbc abfcab
programming contest
abcd mnp
 
Sample Output
4
2
0
 
题目大意:找到最长公共子序列,如:abcfbc abfcab 这个的最长公共子序列为abfc或abcb 所以输出4!
 
题目思路:定义一个dp[i][j]的二维数组。用来表示最长的公共子序列数。i表示第一个字符串的开始位置,j表示第二个字符串的开始位置。也就是从后向前推。dp[0][0]表示从第0个到第n个的最长公共子序列数,因为结尾就是n。dp[n][n]表示的是第n个到第n个的最长公共子序列。
 
详见代码。
 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 
 5 using namespace std;
 6 
 7 int dp[1001][1001];
 8 
 9 int main()
10 {
11     char a[1001],b[1001];
12     while (~scanf("%s%s",a,b))
13     {
14         int len1=strlen(a);
15         int len2=strlen(b);
16         memset(dp,0,sizeof(dp));
17         for (int i=len1-1;i>=0;i--)
18         {
19             for (int j=len2-1;j>=0;j--)
20             {
21                 if (a[i]==b[j])
22                     dp[i][j]=dp[i+1][j+1]+1;
23                 else
24                     dp[i][j]=max(dp[i+1][j],dp[i][j+1]);
25             }
26         }
27         printf ("%d
",dp[0][0]);
28     }
29     return 0;
30 }